/**********************************************************************
  disassemble tH[}bg\
  $Id: dis_print.c,v 1.2 2002/04/29 03:39:13 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

void dis_print_rrd(FILE *fp, int r1, int r2, int d)
{
    fprintf(simmsgfp,"\t%%r%d, %d(%%r%d)\n",r1,d,r2) ;
}  

void dis_print_rri(FILE *fp, int r1, int r2, int i)
{
    fprintf(simmsgfp,"\t%%r%d, %%r%d, %d\n",r1,r2,i) ;
}  

void dis_print_crri(FILE *fp, int cr, int r2, int i)
{
    fprintf(simmsgfp,"\t%%cr%d, %%r%d, %d\n",cr,r2,i) ;
}  

void dis_print_crrr(FILE *fp, int cr, int r1, int r2)
{
    fprintf(simmsgfp,"\t%%cr%d, %%r%d, %%r%d\n",cr,r1,r2) ;
}  

void dis_print_rrddd(FILE *fp, int r1, int r2, int d1, int d2, int d3)
{
    fprintf(simmsgfp,"\t%%r%d, %%r%d, %d, %d, %d\n",r1,r2,d1,d2,d3) ;
}  

void dis_print_r(FILE *fp, int r1)
{
    fprintf(simmsgfp,"\t%%r%d\n",r1) ;
}  

void dis_print_rr(FILE *fp, int r1, int r2)
{
    fprintf(simmsgfp,"\t%%r%d, %%r%d\n",r1,r2) ;
}  

void dis_print_rrr(FILE *fp, int r1, int r2, int r3)
{
    fprintf(simmsgfp,"\t%%r%d, %%r%d, %%r%d\n",r1,r2,r3) ;
}  

void dis_print_fr(FILE *fp, int r1)
{
    fprintf(simmsgfp,"\t%%fr%d\n",r1) ;
}  

void dis_print_frfr(FILE *fp, int r1, int r2)
{
    fprintf(simmsgfp,"\t%%fr%d, %%fr%d\n",r1,r2) ;
}  

void dis_print_frfrfr(FILE *fp, int r1, int r2, int r3)
{
    fprintf(simmsgfp,"\t%%fr%d, %%fr%d, %%fr%d\n",r1,r2,r3) ;
}  

void dis_print_frfrfrfr(FILE *fp, int r1, int r2, int r3, int r4)
{
    fprintf(simmsgfp,"\t%%fr%d, %%fr%d, %%fr%d, %%fr%d\n",r1,r2,r3,r4) ;
}  

void dis_print_crbcrbcrb(FILE *fp, int r1, int r2, int r3)
{
    fprintf(simmsgfp,"\t%%crb%d, %%crb%d, %%crb%d\n",r1,r2,r3) ;
}  

