/**********************************************************************
  gatoi
  $Id: exatoi.c,v 1.1.1.1 2002/01/13 14:59:53 tane Exp $
**********************************************************************/
#include	"common.h"

#define	READ_DEC		0
#define	READ_HEX		1
#define	READ_BIN		2
#define	READ_OCT		3

int	exatoi( unsigned char *p )
{
int	flag ;
int	minus ;
int	ptr ;
int	count ;
int	res ;
int	reading ;

	flag=READ_DEC ;
	minus=0 ;
	switch( p[0] ){
		case '0' :
			switch( p[1] ){
				case 'x':
				case 'X':
					flag=READ_HEX ;
					break ;
				case 'b':
				case 'B':
					flag=READ_BIN ;
					break ;
				case 'o':
				case 'O':
					flag=READ_OCT ;
					break ;
			}
			break ;
		case '-' :
			minus=1 ;
	}

	switch( flag ){
		case READ_HEX :
			res=0 ; count=0 ;
			reading = NO ;
			for( ptr=2,count=0 ; count<8 ; ptr++ ){
				if( p[ptr]=='_' ) continue ;
				if( reading==NO && p[ptr]=='0' ) continue ;
				if( (p[ptr]>='0' && p[ptr]<='9') ){
					res=res*16 ;
					res=res+(p[ptr]-'0') ;
					count++ ;
					reading=YES ;
					continue ;
				}
				if( (p[ptr]>='a' && p[ptr]<='f') ){
					res=res*16 ;
					res=res+(p[ptr]-'a'+10) ;
					count++ ;
					reading=YES ;
					continue ;
				}
				if( (p[ptr]>='A' && p[ptr]<='F') ){
					res=res*16 ;
					res=res+(p[ptr]-'A'+10) ;
					count++ ;
					reading=YES ;
					continue ;
				}
				break ;
			}
			break ;
		case READ_BIN :
			res=0 ; count=0 ;
			reading = NO ;
			for( ptr=2,count=0 ; count<32 ; ptr++ ){
				if( p[ptr]=='_' ) continue ;
				if( reading==NO && p[ptr]=='0' ) continue ;
				if( (p[ptr]>='0' && p[ptr]<='1') ){
					res=res*2 ;
					res=res+(p[ptr]-'0') ;
					count++ ;
					reading=YES ;
					continue ;
				}
				break ;
			}
			break ;
		case READ_OCT :
			res=0 ; count=0 ;
			reading = NO ;
			for( ptr=2,count=0 ; count<11 ; ptr++ ){
				if( p[ptr]=='_' ) continue ;
				if( reading==NO && p[ptr]=='0' ) continue ;
				if( (p[ptr]>='0' && p[ptr]<='7') ){
					res=res*8 ;
					res=res+(p[ptr]-'0') ;
					count++ ;
					reading=YES ;
					continue ;
				}
				break ;
			}
			break ;
		default :
			res=0 ; count=0 ;
			reading = NO ;
			for( ptr=minus,count=0 ; count<10 ; ptr++ ){
				if( p[ptr]=='_' ) continue ;
				if( reading==NO && p[ptr]=='0' ) continue ;
				if( (p[ptr]>='0' && p[ptr]<='9') ){
					res=res*10 ;
					res=res+(p[ptr]-'0') ;
					count++ ;
					reading=YES ;
					continue ;
				}
				break ;
			}
			if( minus==1 ) res=-res ;
	}
	return( res ) ;
}
