/**********************************************************************
  s߃T}\
  $Id: sum_cmd.c,v 1.2 2002/04/29 03:39:14 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"


int sum_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i ;
  long long int sum ;

  if( tk_pt->pt[1]!=NULL ){
    if( strcmp(tk_pt->pt[1],"reset")==0 ){
      reset_exec_op_count() ;
      return(NORMAL_EXIT) ;
    }else{
      fprintf(simmsgfp,"Unknown subcommand (%s).\n",tk_pt->pt[1]) ;
      return(NORMAL_EXIT) ;
    }
  }
    
  sum=0 ;
  for( i=0 ; i<TBL_SIZE_bit00to05 ; i++ ){
    if( op_func_tbl[i].count!=0 ){
      if( i==0x13 || i==0x1f || i==0x3b || i==0x3f ) continue ;
      fprintf(simmsgfp,"%-12s = ",op_func_tbl[i].name) ;
      printll(simmsgfp,op_func_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_func_tbl[i].count ;
    }
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    if( op_13_subfunc_tbl[i].count!=0 ){
      fprintf(simmsgfp,"%-12s = ",op_13_subfunc_tbl[i].name) ;
      printll(simmsgfp,op_13_subfunc_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_13_subfunc_tbl[i].count ;
    }
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    if( op_1f_subfunc_tbl[i].count!=0 ){
      fprintf(simmsgfp,"%-12s = ",op_1f_subfunc_tbl[i].name) ;
      printll(simmsgfp,op_1f_subfunc_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_1f_subfunc_tbl[i].count ;
    }
  }
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    if( op_3b_subfunc_tbl[i].count!=0 ){
      fprintf(simmsgfp,"%-12s = ",op_3b_subfunc_tbl[i].name) ;
      printll(simmsgfp,op_3b_subfunc_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_3b_subfunc_tbl[i].count ;
    }
  }
  for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
    if( op_3f_subfunc0_tbl[i].count!=0 ){
      fprintf(simmsgfp,"%-12s = ",op_3f_subfunc0_tbl[i].name) ;
      printll(simmsgfp,op_3f_subfunc0_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_3f_subfunc0_tbl[i].count ;
    }
  }
  for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
    if( op_3f_subfunc1_tbl[i].count!=0 ){
      fprintf(simmsgfp,"%-12s = ",op_3f_subfunc1_tbl[i].name) ;
      printll(simmsgfp,op_3f_subfunc1_tbl[i].count,12) ;
      fprintf(simmsgfp,"\n") ;
      sum+=op_3f_subfunc1_tbl[i].count ;
    }
  }
  
  fprintf(simmsgfp,"Total_count  = ") ;
  printll(simmsgfp,sum,12) ;
  fprintf(simmsgfp,"\n") ;
  
  return(NORMAL_EXIT) ;
}

